/* Rev:$Revision: 1.0 $ */
/******************************************************************************
 * Copyright 2006 NetBurner, Inc.  ALL RIGHTS RESERVED
 *   Permission is hereby granted to purchasers of NetBurner Hardware
 *   to use or modify this computer program for any use as long as the
 *   resultant program is only executed on NetBurner provided hardware.
 *
 *   No other rights to use this program or it's derivitives in part or
 *   in whole are granted.
 *
 *   It may be possible to license this or other NetBurner software for
 *   use on non NetBurner Hardware. Please contact Licensing@Netburner.com 
 *   for more information.
 *
 *   NetBurner makes no representation or warranties with respect to the 
 *   performance of this computer program, and specifically disclaims any 
 *   responsibility for any damages, special or consequential, connected 
 *   with the use of this program.
 *
 *   NetBurner, Inc
 *   5405 Morehouse Drive
 *   San Diego Ca, 92121
 *   http://www.netburner.com
 *
 *****************************************************************************/
/******************************************************************************
 Macromedia Flash Demo Program
 This is a support file for the Flash demo that handles the connection 
 between the flash application and the NetBurner device.
*****************************************************************************/
#include <predef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <startnet.h>
#include <tcp.h>


#define TCP_LISTEN_PORT (10000) 				
#define RX_BUFSIZE (5000)
#define TX_BUFSIZE (5000)		


char RXBuffer[RX_BUFSIZE]; 
char TXBuffer[TX_BUFSIZE]; 
char cross_domain_policy[] = "<?xml version=\"1.0\"?> <!DOCTYPE cross-domain-policy SYSTEM \"http://www.adobe.com/xml/dtds/cross-domain-policy.dtd\"> <cross-domain-policy> <site-control permitted-cross-domain-policies=\"all\"/> <allow-access-from domain=\"*\" to-ports=\"*\" secure=\"false\"/> <allow-http-request-headers-from domain=\"*\" headers=\"*\"  secure=\"false\"/> </cross-domain-policy>\0";

//char temp_string[TX_BUFSIZE]; 

int LedState = 0;
BYTE LedMask[] = {
    0x0,
    0x1,
    0x2,
    0x4,
    0x8,
    0x10,
    0x20,
    0x40,
    0x80
};


BOOL Connected = FALSE;


/*-------------------------------------------------------------------
 Function to display connected message
 ------------------------------------------------------------------*/
void DisplayConnectedMsg( int sock, PCSTR url )
{
	writestring(sock, "<html><body><h1>Error, a client is already connected</h1></body></html>");
}

static http_gethandler  * oldhand;
/*-------------------------------------------------------------------
 Override GET requests to the web server
 Parameters:
   sock     = Handle to open socket connection from client
   url      = URL client used to get here
   rxBuffer = Pointer to the complete HTTP request
 ------------------------------------------------------------------*/
int MyDoGet( int sock, PSTR url, PSTR rxBuffer )
{
   iprintf( "MyDoGet() URL: %s\r\n", url );

   if ( strlen( url ) )
   {
      // Parse URL requrest and process images
      char name[] = "INDEX.HTM";
      if ( strncmp( url, name, strlen( name ) ) == 0 )
      {
         if ( Connected )
         {
            DisplayConnectedMsg( sock, url );
            return 0;
         }
      }
   }
   return ( *oldhand ) ( sock, url, rxBuffer );
}


/*-------------------------------------------------------------------
 Update The LEDs
 -------------------------------------------------------------------*/
void UpdateLeds(int request)
{
        LedState = request;
        putleds( LedMask[request] );
}


/*-------------------------------------------------------------------
 Send Status of Leds & DIP Switches to Flash Page
 -------------------------------------------------------------------*/
void SendStatus(int fdnet)
{
	// Send data to web page
	char 	status_string[10];
    sprintf( status_string, "$%03u%03u", LedState, getdipsw() );
	write( fdnet, status_string, strlen( status_string ) + 1 );
}


/*-------------------------------------------------------------------
  Network connection handler
 -------------------------------------------------------------------*/
void ConnectionServer( void *pd )
{
	int 	r;
	int 	fdnet;
    int     result=0;
    BYTE    old_switch = getdipsw();

   oldhand = SetNewGetHandler( MyDoGet );

	while (1)
    {
		int fdListen = listen(INADDR_ANY, TCP_LISTEN_PORT, 1);

        if (fdListen > 0)
        {
			while(1)
			{
	           	IPADDR client_addr;
	           	WORD port;
	
	            // Wait here until connection is requested by Flash application
				iprintf("Waiting for connection on port %d...\r\n",TCP_LISTEN_PORT);
				fdnet = accept(fdListen, &client_addr, &port, 0);

				iprintf("Connected to client IP: "); 
                ShowIP(client_addr);
				iprintf("\r\nPort: %d\r\n", port);
				Connected = TRUE;
				
				if(fdnet > 0)
	           		r = ReadWithTimeout(fdnet, RXBuffer, RX_BUFSIZE, TICKS_PER_SECOND/4 );
									           	
	           	// Reply to policy file request
	            if( strcmp( "<policy-file-request/>", RXBuffer ) == 0 )
	            {
	            	iprintf("Sending requested policy file\r\n");
	            	writeall( fdnet, cross_domain_policy, strlen(cross_domain_policy));
		     		close(fdnet);
		     		*RXBuffer = '\0';  // Mark buffer as read 
		     			break;
				}
				else
					SendStatus(fdnet);
	         
				while (fdnet > 0)
				{
                    /* The flash application will send information on the LED, serial data
                     * send, and heartbeat. Wait in this loop until an update message is
                     * received. An update message is a single byte. 
                     */
                    do
                    {
                        r = ReadWithTimeout(fdnet, RXBuffer, RX_BUFSIZE, TICKS_PER_SECOND / 4);   

						// if dip swich is changed, send new data
                        if(getdipsw() != old_switch)
                        {
                           // Send new Switch Data to Flash application
                           old_switch = getdipsw();
                           SendStatus(fdnet);
                        }                            		                  
                    } while( r == 0 );

                       		
					if(r < 0)  // error on read
					{
						break;
	     			}

                    // Process the 8-bit command
                    switch ( RXBuffer[0] ) 
                    {
                    	case '~':			                    // heartbeat signal
	    					write( fdnet, "!", 2 );
	    					break;

                    	case '$': 								// update leds command
	                        RXBuffer[0] = '0';                  // strip out the $ for the atoi
    	                    result = atoi(RXBuffer);

	                        if( (result >=0) && (result <=8) )  // make sure data is valid
	                            UpdateLeds(result);
	                        SendStatus(fdnet);
                    		break;

                    	case '?':                 				// send status update
                	        SendStatus(fdnet);
							break;

                    	default:                                // echo text back to flash app
 				            siprintf(TXBuffer,"%s",RXBuffer);
   							write( fdnet, TXBuffer, strlen( TXBuffer ) + 1 );
                    }
  				}

				iprintf("Closing Connection, Client Quit\r\n");
				close(fdnet);
                putleds(0x00);                     				// turn off LEDs
                Connected = FALSE;

			}
	   	}
    }
}


