/* Rev:$Revision: 1.0 $ */
/******************************************************************************
 * Copyright 2006 NetBurner, Inc.  ALL RIGHTS RESERVED
 *   Permission is hereby granted to purchasers of NetBurner Hardware
 *   to use or modify this computer program for any use as long as the
 *   resultant program is only executed on NetBurner provided hardware.
 *
 *   No other rights to use this program or it's derivitives in part or
 *   in whole are granted.
 *
 *   It may be possible to license this or other NetBurner software for
 *   use on non NetBurner Hardware. Please contact Licensing@Netburner.com 
 *   for more information.
 *
 *   NetBurner makes no representation or warranties with respect to the 
 *   performance of this computer program, and specifically disclaims any 
 *   responsibility for any damages, special or consequential, connected 
 *   with the use of this program.
 *
 *   NetBurner, Inc
 *   5405 Morehouse Drive
 *   San Diego Ca, 92121
 *   http://www.netburner.com
 *
 *****************************************************************************/

/******************************************************************************
 Macromedia Flash Demo Program
 This program demonstrates the use of a Macromedia Flash application with
 your NetBurner device. The application is designed to run on NetBurner
 NNDK-Modxxxx-KIT development boards with 8 LEDs and DIP switches. 
 
 To run the example, use a web browser to connect to the NetBurner device.
 The Flash application will run in the web browser and enables you to 
 change the LEDs and send/receive serial data. Changing a DIP switch on
 the development board will update the display in the Flash application. 
 
 The Flash application was created using Macromedia Flash 8. To modify the
 Flash application you would need to edit the .fla file, export it
 to a .swf file, then copy it to the project html directory. 
 
*****************************************************************************/
#include <predef.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <startnet.h>
#include <dhcpclient.h>
#include <autoupdate.h>
#include <tcp.h>
#include <taskmon.h>
#include <NetworkDebug.h>

extern "C"
{ 
	void UserMain(void * pd); 
	BOOL OnModDev70();
}
extern void ConnectionServer( void *pd );

static DWORD TaskStk_ConnectionServer[USER_TASK_STK_SIZE];
const char *AppName = "NetBurner / Macromedia Flash Demo";

/*-------------------------------------------------------------------
  UserMain
 -------------------------------------------------------------------*/
void UserMain(void * pd)
{
    iprintf("\r\n\r\n...NetBurner Information...\r\n");
    InitializeStack();
    if ( EthernetIP == 0 ) { GetDHCPAddress(); } 
    OSChangePrio( MAIN_PRIO );
    EnableAutoUpdate();    	
    StartHTTP();
    EnableTaskMonitor();
    
   #ifdef _DEBUG
	InitializeNetworkGDB();
   #endif

   if ( OnModDev70() )
      iprintf("mod-dev-70\r\n");
   else
      iprintf("mod-dev-100\r\n");


	// Create server task
    OSTaskCreate( ConnectionServer, 0,
        ( void * ) &TaskStk_ConnectionServer[USER_TASK_STK_SIZE],
        ( void * )  TaskStk_ConnectionServer,
        MAIN_PRIO + 1 );

    putleds(0x00);  // Clear out all LEDs

	// Main task will loop forever
    while ( 1 )
    {
        OSTimeDly( TICKS_PER_SECOND * 10 );
    }
}




